package jp.co.y_net.amm.dao;
import java.util.List;

import org.hibernate.criterion.DetachedCriteria;
import org.hibernate.criterion.Example;
import org.springframework.orm.hibernate3.HibernateTemplate;
import org.springframework.stereotype.Component;


@Component("grpusrDao")
public class GrpusrDao extends AbstractDao {
    
    /* 参照形処理 ------------------------------------------------------------------------------------------------ */
    /** ユニークキーを使用した取得 */
    public Grpusr getByGrpusrid(Integer grpusrid) {
        Grpusr cnd = new Grpusr();
        cnd.setGrpusrid(grpusrid);
        List<Grpusr> list = get(cnd);
        if(list.size() == 1) {
            return list.get(0);
        }
        return null;
    }
    /** 全件取得(論理削除除外) */
    public List<Grpusr> get() {
        Grpusr cnd = new Grpusr();
        cnd.setDeleted(AppDef.FLASE); // 論理削除考慮
        return get(cnd);
    }
    /** 条件付き取得(論理削除除外) */
    public List<Grpusr> get(Grpusr cnd) {
        if(cnd != null) {
            cnd.setDeleted(AppDef.FLASE); // 論理削除考慮
        }
        HibernateTemplate hibernateTemplate = getHibernateTemplate();
        DetachedCriteria dc = DetachedCriteria.forClass(Grpusr.class);
        dc.add(Example.create(cnd));
        @SuppressWarnings("unchecked")
        List<Grpusr> list = (List<Grpusr>) hibernateTemplate.findByCriteria(dc);
        hibernateTemplate.clear();
        return list;
    }

    /* 更新系処理 ------------------------------------------------------------------------------------------------ */
    private static final String ENTITYNAME = "Grpusr";
    private static final String PKEYNAME = "grpusrid";
    /**
     * 登録処理
     * ・必要なカラムを自動採番する
     * ・共通処理を実施する。
     * @see AbstractDao#add(AppDto, Integer)
     * @param item 追加対象オブジェクト
     * @param updateusrid 更新者ID
     */
    public void add(Grpusr item, Integer updateusrid) {
        /* 自動採番 */
        item.setGrpusrid(getNextId(ENTITYNAME, PKEYNAME));
        /* Insert実施 */
        super.add(item, updateusrid);
    }
    public void update(Grpusr item, Integer updateusrid) {
        super.update(item, updateusrid);
    }
    public void removeLogical(Grpusr item, Integer updateusrid) {
        super.removeLogical(item, updateusrid);
    }
    
    /* entity固有のユーティリティ ----------------------------------------------------------------------------------- */
    /**
     * 所属メンバー数
     * @param grpid 
     * @return
     */
    public String getMembercount参加中AsString(Integer grpid) {
        return String.valueOf(getMembercount参加中(grpid));
    }
    /**
     * 所属メンバー数
     * @param grpid 
     * @return
     */
    public Integer getMembercount参加中(Integer grpid) {
        Grpusr cndGu = new Grpusr();
        cndGu.setGrpid(grpid);
        cndGu.setStatus(Grpusr.STATUS_参加中);
        List<Grpusr> member = this.get(cndGu);
        return member.size();
    }




}
